---
title: "Setting Live ‘Ad Traffic By Keywords’ Tasks"
url: "https://docs.dataforseo.com/v3/keywords_data/google_ads/ad_traffic_by_keywords/live/"
date: "2026-06-06"
---

## Setting Live ‘Ad Traffic By Keywords’ Tasks

#### Please note that starting from June 1, Google Ad Traffic By Keywords returns bulk data for the entire campaign (all keywords specified when setting a task). You can learn more in [this update](https://dataforseo.com/update/changes-google-ad-traffic-by-keywords).

Note that Google Ads Keywords Data API is based on the latest version of the [Google Ads API](https://developers.google.com/google-ads/api/docs/start) that has replaced legacy Google AdWords API. If you’re using [DataForSEO Google AdWords API](https://docs.dataforseo.com/v3/keywords_data/google/overview.md), you need to upgrade to [DataForSEO Google Ads API](https://docs.dataforseo.com/v3/keywords_data/google_ads/overview.md).  
   
**Note: you can send no more than 12 requests per minute per account using Google Ads Live endpoints.**

Using the Ad Traffic By Keywords endpoint, you can receive a set of stats for estimating impressions, CPC, and clicks. This data is really useful for estimating real demand for a specific keyword, as it is much more accurate than the regular search volume information, which shows the broad match estimation for a group of similar keywords.

Note that Google Ads API provides account-specific results based on ad history, creatives already in the account, and other factors. Use high `bid` to level other factors.

The values you receive in the response depend on the set forecasting time period. There are two ways to specify the necessary time period:

1\. By indicating the exact dates in the future using `date_from` and `date_to`;  
2\. By setting the `date_interval` to `next_week`, `next_month`, or `next_quarter`

If you do not use one of the ways above, the forecasting time period of `next_month` will be applied by default.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/keywords\_data/google\_ads/ad\_traffic\_by\_keywords/live     

      

Pricing

 Your account will be charged for each request.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/keywords-data/google-ads "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute. Visit [DataForSEO Help Center](https://dataforseo.com/help-center/best-practices-for-handling-keywords-data-api-requests) to get practical tips for request handling depending on your Keyword Data API payload volume.

You can send up to 1000 keywords in one `keywords` array. Our system will charge your account per request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

Below you will find a detailed description of the fields you can use for setting a task.

**Description of the fields for setting a task:**

optional field

| Field name | Type | Description |
|---|---|---|
| `keywords` | array | *keywords*   **required field**   The maximum number of keywords you can specify: 1000   The maximum number of characters for each keyword: 80   The maximum number of words for each keyword phrase: 10   the keywords you specify will be converted to a lowercase format   **Note:** Google Ads may return no data for certain groups of keywords   [visit our Help Center to learn more](https://dataforseo.com/help-center/no-search-volume-data-for-some-keywords)   **Also note** that Google Ads doesn’t allow using certain symbols and characters (e.g., UTF symbols, emojis), so you can’t use them when setting a task;   to learn more about which symbols and characters can be used, please refer to [this article](https://dataforseo.com/help-center/using-symbols-in-keywords-when-setting-a-google-ads-task)learn more about rules and limitations of `keyword` and `keywords` fields in DataForSEO APIs in this [Help Center article](https://dataforseo.com/help-center/rules-and-limitations-of-keyword-and-keywords-fields-in-dataforseo-apis) |
| `bid` | integer | *the maximum custom bid*   **required field**   the collected data will be based on this value   it stands for the price you are willing to pay for an ad; the higher value you specify here, the higher values you will get in the returned metrics   learn more in [this help center article](https://dataforseo.com/help-center/configuring-bid) |
| `match` | string | *keywords match-type*   **required field**   can take the following values: `exact`, `broad`, `phrase` |
| `location_name` | string | *full name of search engine location*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_code` or `location_coordinate`**   you can receive the list of available locations of the search engine with their `location_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/locations`   example:   `London,England,United Kingdom` |
| `location_code` | integer | *search engine location code*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_name` or `location_coordinate`**;   you can receive the list of available locations of the search engines with their `location_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/locations`   example:   `2840` |
| `location_coordinate` | string | *GPS coordinates of a location*   optional field   if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;   **if you use this field, you don’t need to specify `location_name` or `location_code`**;   `location_coordinate` parameter should be specified in the *“latitude,longitude”* format;   **the data will be provided for the country the specified coordinates belong to**;   example:   `52.6178549,-155.352142` |
| `language_name` | string | *full name of search engine language*   optional field   you can receive the list of available languages of the search engine with their `language_name` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/languages`   example:   `English` |
| `language_code` | string | *search engine language code*   optional field   you can receive the list of available languages of the search engine with their `language_code` by making a separate request to `https://api.dataforseo.com/v3/keywords_data/google_ads/languages`   example:   `en` |
| `date_from` | string | *starting date of the forecasting time range*   required field if you specify `date_to`   **if you indicate `date_from` and `date_to`, you don’t need to specify `date_interval`**   minimum value is tomorrow’s date   the value you specify in `date_from` shouldn’t be further than `date_to`   date format: `"yyyy-mm-dd"`   example:   `"2021-10-30"`if [Status endpoint](https://docs.dataforseo.com/v3/keywords_data/google_ads/status.md) returns `false` in the `actual_data` field, `date_from` can be set to the month before last and prior;   if [Status endpoint](https://docs.dataforseo.com/v3/keywords_data/google_ads/status.md) returns `true` in the `actual_data` field, `date_from` can be set to the last month and prior |
| `date_to` | string | *ending date of the forecasting time range*   required field if you specify `date_from`   **if you indicate `date_from` and `date_to`, you don’t need to specify `date_interval`**   minimum value is `date_from` +1 day   maximum value is current day and month of the next year   date format: `"yyyy-mm-dd"`   example:   `"2022-10-30"` |
| `date_interval` | string | *forecasting date interval*   optional field   **if you specify `date_interval`, you don’t need to indicate `date_from` and `date_to`**   possible values: `next_week`, `next_month`, `next_quarter`   default value: `next_month` |
| `sort_by` | string | *results sorting parameters*   optional field   Use these parameters to sort the results by `relevance`, `impressions`, `ctr`, `average_cpc`, `cost`, or `clicks` in the descending order   default value: `relevance` |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` object of the response |

  
As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks.

**Description of the fields in the result array:**

| `version` | string | *the current version of the API* |
|---|---|---|
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total *tasks* cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`** array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *task identifier*   **unique task identifier in our system in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*   generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of response codes [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results* |
| `keyword` | string | *keyword in a POST array* |
| `location_code` | integer | *location code in a POST array*   if there is no data, then the value is `null` |
| `language_code` | string | *language code in a POST array*   if there is no data, then the value is `null` |
| `date_interval` | string | *forecasting date interval in a POST array* |
| `search_partners` | boolean | *include Google search partners*   the value you specified when setting the task   **Note:** parameter deprecated, the value is always `false` |
| `bid` | integer | *the maximum custom bid*   the bid you have specified when setting the task   represents the price you are willing to pay for an ad   the higher value you have specified, the higher metrics and cost you receive in response   learn more in [this help center article](https://dataforseo.com/help-center/configuring-bid) |
| `match` | string | *keywords match-type*   can take the following values: `exact`, `broad`, `phrase` |
| `impressions` | float | *projected number of ad impressions*   number of impressions an ad is projected to get within the specified time period   **Note:** parameter deprecated, the value is always `null` |
| `ctr` | float | *projected click through rate (CTR) of the advertisement*   number of clicks an ad is projected to receive divided by the number of ad impressions; the CTR is projected for the specified time period   **Note:** parameter deprecated, the value is always `null` |
| `average_cpc` | float | *the average cost-per-click value*   represents the cost-per-click (USD) estimated for a keyword based on the specified time period and historical data;   if there is no data, then the value is `null` |
| `cost` | float | *charge for an ad*   amount that will be charged for running an ad within the specified time period   if there is no data, then the value is `null` |
| `clicks` | float | *number of clicks on an ad*   number of clicks an ad is projected to get within the specified time period   if there is no data, then the value is `null` |



 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/google_ads/ad_traffic_by_keywords/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "location_code": 2840,
        "language_code": "en",
        "bid": 999,
        "match": "exact",
        "keywords": [
            "seo marketing"
        ]
    }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_name" => "United States",
	"language_name" => "English",
	"bid" => 999,
	"match" => "exact",
	"keywords" => array(
		"seo marketing"
	)
);
try {
	// POST /v3/keywords_data/google_ads/ad_traffic_by_keywords/live
	// the full list of possible parameters is available in documentation
	$result = $client->post('/v3/keywords_data/google_ads/ad_traffic_by_keywords/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
```





```js
const post_array = [];

post_array.push({
  "location_name": "United States",
  "language_name": "English",
  "bid": 999,
  "match": "exact",
  "keywords": ["seo marketing"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/google_ads/ad_traffic_by_keywords/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
```





```python
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    language_name="English",
    bid=999,
	match="exact",
	keywords=[
		"seo marketing"
    ]
)
# POST /v3/keywords_data/google_ads/ad_traffic_by_keywords/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/google_ads/ad_traffic_by_keywords/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
```





```csharp
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_ad_traffic_by_keywords_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_name = "United States",
                language_name = "English",
                bid = 999,
                match = "exact",
                keywords = new[]
                    {
                        "seo marketing"
                    }
            });
            // POST /v3/keywords_data/google_ads/ad_traffic_by_keywords/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/google_ads/ad_traffic_by_keywords/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic&gt(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20221214",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "3.5834 sec.",
  "cost": 0.075,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "06021415-1535-0370-0000-278442b1d470",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "3.5198 sec.",
      "cost": 0.075,
      "result_count": 1,
      "path": [
        "v3",
        "keywords_data",
        "google_ads",
        "ad_traffic_by_keywords",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "ad_traffic_by_keywords",
        "se": "google_ads",
        "language_code": "en",
        "location_code": 2840,
        "bid": 999,
        "match": "exact",
        "keywords": [
          "buy laptop",
          "cheap laptops for sale",
          "purchase laptop"
        ]
      },
      "result": [
        {
          "keyword": null,
          "location_code": 2840,
          "language_code": "en",
          "date_interval": "next_month",
          "search_partners": false,
          "bid": 999,
          "match": "exact",
          "impressions": 5330.81,
          "ctr": 0.0862,
          "average_cpc": 5.58,
          "cost": 2562.44,
          "clicks": 459.42
        }
      ]
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp